

#/particle minecraft:scrape

execute as @a at @s anchored eyes positioned ^ ^ ^1 align xyz positioned ~.5 ~.5 ~.5 if block ~ ~ ~ #zapped:block unless entity @e[type=marker,tag=zapped,distance=...001] run return run summon marker ~ ~ ~ {Tags:["zapped"]}
execute as @a at @s anchored eyes positioned ^ ^ ^2 align xyz positioned ~.5 ~.5 ~.5 if block ~ ~ ~ #zapped:block unless entity @e[type=marker,tag=zapped,distance=...001] run return run summon marker ~ ~ ~ {Tags:["zapped"]}
execute as @a at @s anchored eyes positioned ^ ^ ^3 align xyz positioned ~.5 ~.5 ~.5 if block ~ ~ ~ #zapped:block unless entity @e[type=marker,tag=zapped,distance=...001] run return run summon marker ~ ~ ~ {Tags:["zapped"]}
execute as @a at @s anchored eyes positioned ^ ^ ^4 align xyz positioned ~.5 ~.5 ~.5 if block ~ ~ ~ #zapped:block unless entity @e[type=marker,tag=zapped,distance=...001] run return run summon marker ~ ~ ~ {Tags:["zapped"]}


#visual
execute as @e[type=minecraft:marker,tag=zap] at @s if block ~ ~ ~ lightning_rod[facing=up] run particle electric_spark ~ ~ ~ 0.06 0.25 0.06 0.02 1
execute as @e[type=minecraft:marker,tag=zap] at @s if block ~ ~ ~ lightning_rod[facing=north] run particle electric_spark ~ ~ ~ 0.06 0.06 0.25 0.02 1
execute as @e[type=minecraft:marker,tag=zap] at @s if block ~ ~ ~ lightning_rod[facing=east] run particle electric_spark ~ ~ ~ 0.25 0.06 0.06 0.02 1

execute as @e[type=minecraft:marker,tag=zap] at @s if block ~ ~ ~ lightning_rod[facing=down] run particle electric_spark ~ ~ ~ 0.06 0.25 0.06 0.02 1
execute as @e[type=minecraft:marker,tag=zap] at @s if block ~ ~ ~ lightning_rod[facing=south] run particle electric_spark ~ ~ ~ 0.06 0.06 0.25 0.02 1
execute as @e[type=minecraft:marker,tag=zap] at @s if block ~ ~ ~ lightning_rod[facing=west] run particle electric_spark ~ ~ ~ 0.25 0.06 0.06 0.02 1

#battery render 2

execute as @e[tag=display] at @s run tp @s ~ ~ ~ ~10 ~



#other tick
scoreboard players add @e[tag=score,type=marker] delay 1
execute if score @e[tag=score,type=marker,limit=1] delay matches 5 run function zapped:5th_tick
execute if score @e[tag=score,type=marker,limit=1] delay matches 10 run scoreboard players set @e[tag=score,type=marker] delay 0

#lifetime
scoreboard players add @e[type=minecraft:marker,tag=zap] lifetime 1
scoreboard players add @e[type=minecraft:marker,tag=block] lifetime 1
execute as @e[type=minecraft:marker,tag=zap] if score @s lifetime matches 1000.. run kill @s
execute as @e[type=minecraft:marker,tag=block] if score @s lifetime matches 20.. run kill @s

#netherite
execute as @e[tag=falling,type=falling_block] at @s if score @s charge matches 3.. align xyz positioned ~0.5 ~0.5 ~0.5 run function zapped:netherite/netherite_zap
execute as @e[tag=falling,type=falling_block] at @s if score @s charge matches 6.. align xyz positioned ~0.5 ~0.5 ~0.5 run function zapped:netherite/netherite_zap
execute as @e[tag=falling,type=falling_block] at @s if score @s charge matches 10.. align xyz positioned ~0.5 ~0.5 ~0.5 run function zapped:netherite/netherite_zap

execute as @e[type=falling_block,tag=falling] at @s if score @s charge matches 6.. run particle scrape ~ ~ ~ 0.4 0.4 0.4 4 15
execute as @e[type=falling_block,tag=falling] at @s if score @s charge matches 10.. run particle lava ~ ~ ~ 0.3 0.3 0.3 2 10


#wire
execute as @e[type=minecraft:marker,tag=zap] at @s if block ~ ~1 ~ #zapped:copper if block ~ ~ ~ minecraft:lightning_rod[facing=up] positioned ~ ~1 ~ unless entity @e[type=marker,tag=zap,distance=...01] run tp @s ~ ~ ~
execute as @e[type=minecraft:marker,tag=zap] at @s if block ~ ~-1 ~ #zapped:copper if block ~ ~ ~ minecraft:lightning_rod[facing=down] positioned ~ ~-1 ~ unless entity @e[type=marker,tag=zap,distance=...01] run tp @s ~ ~ ~
execute as @e[type=minecraft:marker,tag=zap] at @s if block ~1 ~ ~ #zapped:copper if block ~ ~ ~ minecraft:lightning_rod[facing=east] positioned ~1 ~ ~ unless entity @e[type=marker,tag=zap,distance=...01] run tp @s ~ ~ ~
execute as @e[type=minecraft:marker,tag=zap] at @s if block ~-1 ~ ~ #zapped:copper if block ~ ~ ~ minecraft:lightning_rod[facing=west] positioned ~-1 ~ ~ unless entity @e[type=marker,tag=zap,distance=...01] run tp @s ~ ~ ~
execute as @e[type=minecraft:marker,tag=zap] at @s if block ~ ~ ~1 #zapped:copper if block ~ ~ ~ minecraft:lightning_rod[facing=south] positioned ~ ~ ~1 unless entity @e[type=marker,tag=zap,distance=...01] run tp @s ~ ~ ~
execute as @e[type=minecraft:marker,tag=zap] at @s if block ~ ~ ~-1 #zapped:copper if block ~ ~ ~ minecraft:lightning_rod[facing=north] positioned ~ ~ ~-1 unless entity @e[type=marker,tag=zap,distance=...01] run tp @s ~ ~ ~

#wire_block
execute as @e[type=minecraft:marker,tag=zap] at @s if block ~ ~-1 ~ minecraft:lightning_rod[facing=down] if block ~ ~ ~ #zapped:copper positioned ~ ~-1 ~ unless entity @e[type=marker,tag=zap,distance=...01] run tp @s ~ ~ ~
execute as @e[type=minecraft:marker,tag=zap] at @s if block ~ ~1 ~ minecraft:lightning_rod[facing=up] if block ~ ~ ~ #zapped:copper positioned ~ ~1 ~ unless entity @e[type=marker,tag=zap,distance=...01] run tp @s ~ ~ ~
execute as @e[type=minecraft:marker,tag=zap] at @s if block ~1 ~ ~ minecraft:lightning_rod[facing=east] if block ~ ~ ~ #zapped:copper positioned ~1 ~ ~ unless entity @e[type=marker,tag=zap,distance=...01] run tp @s ~ ~ ~
execute as @e[type=minecraft:marker,tag=zap] at @s if block ~-1 ~ ~ minecraft:lightning_rod[facing=west] if block ~ ~ ~ #zapped:copper positioned ~-1 ~ ~ unless entity @e[type=marker,tag=zap,distance=...01] run tp @s ~ ~ ~
execute as @e[type=minecraft:marker,tag=zap] at @s if block ~ ~ ~1 minecraft:lightning_rod[facing=south] if block ~ ~ ~ #zapped:copper positioned ~ ~ ~1 unless entity @e[type=marker,tag=zap,distance=...01] run tp @s ~ ~ ~
execute as @e[type=minecraft:marker,tag=zap] at @s if block ~ ~ ~-1 minecraft:lightning_rod[facing=north] if block ~ ~ ~ #zapped:copper positioned ~ ~ ~-1 unless entity @e[type=marker,tag=zap,distance=...01] run tp @s ~ ~ ~


#wire_direction
execute as @e[type=minecraft:marker,tag=zap] at @s if block ~ ~-1 ~ minecraft:lightning_rod[facing=down] if block ~ ~ ~ minecraft:lightning_rod[facing=down] positioned ~ ~-1 ~ unless entity @e[type=marker,tag=zap,distance=...01] run tp @s ~ ~ ~
execute as @e[type=minecraft:marker,tag=zap] at @s if block ~ ~1 ~ minecraft:lightning_rod[facing=up] if block ~ ~ ~ minecraft:lightning_rod[facing=up] positioned ~ ~1 ~ unless entity @e[type=marker,tag=zap,distance=...01] run tp @s ~ ~ ~
execute as @e[type=minecraft:marker,tag=zap] at @s if block ~1 ~ ~ minecraft:lightning_rod[facing=east] if block ~ ~ ~ minecraft:lightning_rod[facing=east] positioned ~1 ~ ~ unless entity @e[type=marker,tag=zap,distance=...01] run tp @s ~ ~ ~
execute as @e[type=minecraft:marker,tag=zap] at @s if block ~-1 ~ ~ minecraft:lightning_rod[facing=west] if block ~ ~ ~ minecraft:lightning_rod[facing=west] positioned ~-1 ~ ~ unless entity @e[type=marker,tag=zap,distance=...01] run tp @s ~ ~ ~
execute as @e[type=minecraft:marker,tag=zap] at @s if block ~ ~ ~1 minecraft:lightning_rod[facing=south] if block ~ ~ ~ minecraft:lightning_rod[facing=south] positioned ~ ~ ~1 unless entity @e[type=marker,tag=zap,distance=...01] run tp @s ~ ~ ~
execute as @e[type=minecraft:marker,tag=zap] at @s if block ~ ~ ~-1 minecraft:lightning_rod[facing=north] if block ~ ~ ~ minecraft:lightning_rod[facing=north] positioned ~ ~ ~-1 unless entity @e[type=marker,tag=zap,distance=...01] run tp @s ~ ~ ~

#delete
execute as @e[type=marker,tag=zap] at @s unless block ~ ~ ~ #zapped:rod unless block ~ ~ ~ #zapped:copper unless block ~ ~ ~ #zapped:chiseled run kill @s
execute as @e[type=marker,tag=zapped] at @s unless block ~ ~ ~ #zapped:block run kill @s
execute as @e[type=block_display,tag=display] at @s unless block ~ ~ ~ #zapped:battery run kill @s
execute as @e[type=minecraft:marker,tag=core] at @s unless block ~ ~ ~ heavy_core run kill @s


#damage
execute as @a at @s if block ~ ~ ~ minecraft:lightning_rod if entity @e[type=minecraft:marker,distance=..1,tag=zap] run damage @s 2 minecraft:lightning_bolt
execute as @a at @s if block ~ ~1 ~ minecraft:lightning_rod if entity @e[type=minecraft:marker,distance=..2,tag=zap] run damage @s 2 minecraft:lightning_bolt

#power
execute at @e[type=minecraft:lightning_bolt] align xyz run summon marker ~0.5 ~-0.5 ~0.5 {Tags:["zap"]}
execute at @e[type=minecraft:lightning_bolt] align xyz run summon marker ~0.5 ~-0.5 ~0.5 {Tags:["zap"]}
execute at @e[type=minecraft:lightning_bolt] align xyz run summon marker ~0.5 ~-0.5 ~0.5 {Tags:["zap"]}
execute at @e[type=minecraft:lightning_bolt] align xyz run summon marker ~0.5 ~-1.5 ~0.5 {Tags:["zap"]}
execute at @e[type=minecraft:lightning_bolt] align xyz run summon marker ~0.5 ~-1.5 ~0.5 {Tags:["zap"]}


execute as @e[type=minecraft:marker,tag=zapped] at @s if predicate zapped:solar run scoreboard players add @s power 1

execute as @e[type=minecraft:marker,tag=zapped] at @s if block ~ ~ ~ #zapped:power[lit=true] run scoreboard players add @s power 1
execute as @e[type=minecraft:marker,tag=zapped] at @s unless block ~ ~ ~ daylight_detector if score @s power matches 2000 positioned ~ ~1 ~ unless entity @e[type=marker,tag=zap,distance=...01] run summon marker ~ ~ ~ {Tags:["zap"]}
execute as @e[type=minecraft:marker,tag=zapped] at @s if block ~ ~ ~ daylight_detector if score @s power matches 2000 positioned ~ ~-1 ~ unless entity @e[type=marker,tag=zap,distance=...01] run summon marker ~ ~ ~ {Tags:["zap"]}
execute as @e[type=minecraft:marker,tag=zapped] at @s unless block ~ ~ ~ daylight_detector if score @s power matches 2000.. run scoreboard players set @s power 0
execute as @e[type=minecraft:marker,tag=zapped] at @s if block ~ ~ ~ daylight_detector if score @s power matches 2000.. run scoreboard players set @s power 0
execute as @e[type=minecraft:marker,tag=zapped] at @s if block ~ ~ ~ #zapped:power[lit=false] run scoreboard players set @s power 0


#sculk
execute as @e[type=minecraft:marker,tag=zapped] at @s if block ~ ~ ~ sculk_catalyst[bloom=true] run summon marker ~ ~-1 ~ {Tags:["zap"]}


#charge
execute as @a[nbt={Inventory:[{id:"minecraft:leather_boots",Slot:100b,components:{"minecraft:custom_data":{zap:copper_armor}}}]}] at @s align xyz positioned ~.5 ~-.5 ~.5 if block ~ ~ ~ #zapped:copper if entity @e[type=marker,tag=zap,distance=..01] run function zapped:armor_charge/boot_charged
execute as @a[nbt={Inventory:[{id:"minecraft:leather_leggings",Slot:101b,components:{"minecraft:custom_data":{zap:copper_armor}}}]}] at @s align xyz positioned ~.5 ~-.5 ~.5 if block ~ ~ ~ #zapped:copper if entity @e[type=marker,tag=zap,distance=..01] run function zapped:armor_charge/legging_charged
execute as @a[nbt={Inventory:[{id:"minecraft:leather_chestplate",Slot:102b,components:{"minecraft:custom_data":{zap:copper_armor}}}]}] at @s align xyz positioned ~.5 ~-.5 ~.5 if block ~ ~ ~ #zapped:copper if entity @e[type=marker,tag=zap,distance=..01] run function zapped:armor_charge/chestplate_charged
execute as @a[nbt={Inventory:[{id:"minecraft:leather_helmet",Slot:103b,components:{"minecraft:custom_data":{zap:copper_armor}}}]}] at @s align xyz positioned ~.5 ~-.5 ~.5 if block ~ ~ ~ #zapped:copper if entity @e[type=marker,tag=zap,distance=..01] run function zapped:armor_charge/helmet_charged

execute as @a[nbt={SelectedItem:{components:{"minecraft:custom_data":{zap:copper_tool}}}}] at @s align xyz positioned ~.5 ~-.5 ~.5 if block ~ ~ ~ #zapped:copper if entity @e[type=marker,tag=zap,distance=..01] run function zapped:tool_charge/all





#end
execute as @e[type=minecraft:marker,tag=chunk] at @s in minecraft:overworld if block ~ ~ ~ lodestone in minecraft:the_end if block ~ ~ ~ lodestone run function zapped:end/end_portal


#unreleased(netherlodestone)-execute as @e[type=minecraft:marker,tag=chunk] at @s in minecraft:overworld if block ~ ~ ~ lodestone in minecraft:the_nether if block ~ ~ ~ lodestone run function zapped:end/nether_portal



#bulb
execute as @e[tag=bulb,type=minecraft:marker] at @s if predicate zapped:bulb run fill ~4 ~4 ~4 ~-4 ~-4 ~-4 air replace minecraft:light

execute as @e[type=minecraft:marker,tag=bulb] at @s if block ~ ~ ~ #zapped:bulb[lit=true] if score @s charge matches 3..7 run fill ~4 ~4 ~4 ~-4 ~-4 ~-4 minecraft:light[level=8] replace air
execute as @e[type=minecraft:marker,tag=bulb] at @s if block ~ ~ ~ #zapped:bulb[lit=true] if score @s charge matches 8..10 run fill ~4 ~4 ~4 ~-4 ~-4 ~-4 minecraft:light[level=10] replace air
execute as @e[type=minecraft:marker,tag=bulb] at @s if block ~ ~ ~ #zapped:bulb[lit=true] if score @s charge matches 11..13 run fill ~4 ~4 ~4 ~-4 ~-4 ~-4 minecraft:light[level=12] replace air
execute as @e[type=minecraft:marker,tag=bulb] at @s if block ~ ~ ~ #zapped:bulb[lit=true] if score @s charge matches 14..16 run fill ~4 ~4 ~4 ~-4 ~-4 ~-4 minecraft:light[level=14] replace air



